from twisted.internet import defer, reactor
from twisted.trial import unittest

from p2pool.bitcoin import data, networks, p2p
from p2pool.util import deferral


class Test(unittest.TestCase):
    @defer.inlineCallbacks
    def test_get_block(self):
        factory = p2p.ClientFactory(networks.nets['bitcoin'])
        c = reactor.connectTCP('127.0.0.1', 8333, factory)
        try:
            h = 0x000000001c920d495e1eeef2452b6d1c6c229a919b28196c103ecffebabee141
            block = yield deferral.retry()(defer.inlineCallbacks(lambda: defer.returnValue((yield (yield factory.getProtocol()).get_block(h)))))()
            print block
            open('x', 'w').write(repr(block))
        finally:
            factory.stopTrying()
            c.disconnect()
